;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; Appends lpszStr2 on lpszStr1 and returns the new character ;
; count of lpszStr1 excluding null-terminated character      ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


StrLenW                      PROTO :DWORD


.CODE

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

StrCatW PROC p_lpszStr1:DWORD, p_lpszStr2:DWORD

   push edi

   mov edi, [esp+8]
   invoke StrLenW, edi
   mov edx, [esp+12]
   add eax, eax
   add edi, eax
   xor eax, eax

   align 16
@@:
   mov cx, [edx+eax]
   mov [edi+eax], cx
   add eax, 2
   test cx, cx
   jnz @B

   lea eax, [edi+eax-2]
   sub eax, [esp+8]
   shr eax, 1

   pop edi
   ret 8

StrCatW ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

END