;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; Copy lpszStr2 into lpszStr1 and return the character count ;
; copied from lpszStr2 to lpszStr1, excluding the null-      ;
; terminated character                                       ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


.CODE

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

StrCpyA PROC p_lpszStr1:DWORD, p_lpszStr2:DWORD

   push edi

   mov edi, [esp+8]
   mov edx, [esp+12]
   xor eax, eax

   align 8
@@:
   mov cl, [edx+eax]
   mov [edi+eax], cl
   add eax, 1
   test cl, cl
   jnz @B

   sub eax, 1

   pop edi
   ret 8

StrCpyA ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

END