;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; Returns the character count of lpszStr excluding the null- ;
; terminated character                                       ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


.CODE

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

StrLenA PROC p_lpszStr:DWORD

   mov eax, [esp+4]

   align 16
@@:
   mov edx, [eax]
   add eax, 4
   test edx, 0FFh
   jz @0
   test edx, 0FF00h
   jz @1
   test edx, 0FF0000h
   jz @2
   test edx, 0FF000000h
   jnz @B

@3:
   sub eax, 1
   sub eax, [esp+4]
   ret 4

@2:
   sub eax, 2
   sub eax, [esp+4]
   ret 4

@1:
   sub eax, 3
   sub eax, [esp+4]
   ret 4

@0:
   sub eax, 4
   sub eax, [esp+4]
   ret 4

StrLenA ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

END