;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; Returns the character count of lpszStr excluding the null- ;
; terminated character                                       ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


.CODE

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

StrLenW PROC p_lpszStr:DWORD

   mov eax, [esp+4]
   sub eax, 8

   align 4
@@:
   add eax, 8
   cmp word ptr [eax], 0
   je @0
   cmp word ptr [eax+2], 0
   je @2
   cmp word ptr [eax+4], 0
   je @4
   cmp word ptr [eax+6], 0
   jne @B

@6:
   add eax, 6
   sub eax, [esp+4]
   shr eax, 1
   ret 4

@4:
   add eax, 4
   sub eax, [esp+4]
   shr eax, 1
   ret 4

@2:
   add eax, 2
   sub eax, [esp+4]
   shr eax, 1
   ret 4

@0:
   sub eax, [esp+4]
   shr eax, 1
   ret 4

StrLenW ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

END