;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; Get the extension of lpszPath into lpBuffer                ;
;                                                            ;
; Returns the lpBuffer pointer in EAX if successfull or NULL ;
; otherwise.                                                 ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


INCLUDE \GeneSys\include\windows.inc


StrCpyA                      PROTO :DWORD, :DWORD


.CODE

;
; lpBuffer        : MAX_PATH length buffer to get extension and internal use
; lpszPath        : Path to process
;
GetPathExtensionA PROC p_lpBuffer:DWORD, p_lpszPath:DWORD

   invoke StrCpyA, p_lpBuffer, p_lpszPath
   cmp eax, 6
   jb Failed

   mov edx, p_lpBuffer

   align 4
@@:
   sub eax, 1
   jz Failed
   cmp byte ptr [edx+eax], 5Ch   ; "\"
   je Failed
   cmp byte ptr [edx+eax], 2Eh   ; "."
   jne @B

   lea eax, [edx+eax+1]
   ret

Failed:

   xor eax, eax
   ret

GetPathExtensionA ENDP

END
