;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; Appends lpszStr2 on lpszStr1 and returns the new character ;
; count of lpszStr1 excluding null-terminated character      ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


StrLenA                      PROTO :DWORD


.CODE

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

StrCatA PROC p_lpszStr1:DWORD, p_lpszStr2:DWORD

   push edi

   mov edi, [esp+8]
   invoke StrLenA, edi
   mov edx, [esp+12]
   add edi, eax
   xor eax, eax

   align 16
@@:
   mov cl, [edx+eax]
   mov [edi+eax], cl
   add eax, 1
   test cl, cl
   jnz @B

   lea eax, [edi+eax-1]
   sub eax, [esp+8]

   pop edi
   ret 8

StrCatA ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

END